	.module PIr_IO.c
	.area text(rom, con, rel)
	.dbfile F:\Leiterplatten\SBC8535\Praktiker\PROJEK~1\Firmware\PIr_IO.c
	.dbfunc e port_init _port_init fV
	.even
_port_init::
	.dbline -1
	.dbline 31
; //****************************************************************************************************
; //****************************************************************************************************
; // -Butler main
; // all rights itm-praktiker
; // www.praktiker.at
; 
; // enthlt i/o-function
; // Datum: 05/06/2005
; // Rev.:00
; //
; //  Compiler options: Strings in flash only, small model of printf, 8515
; //
; //  Revision history:
; //
; //****************************************************************************************************
; //****************************************************************************************************
; 
; // Target: AT90S8535
; 
; #include <io8535v.h>
; #include <macros.h>
; #include "PIr_BaseType.h"
; #include "PIr_glob.h"
; #include "PIr_Prot.h"
; 
; 
; //------------------------------------------------------------------------------------------------------------
; //------------------------------------------------------------------------------------------------------------
; 
; void port_init(void)  /* */
; {
	.dbline 32
;  PORTA=0x07;
	ldi R24,7
	out 0x1b,R24
	.dbline 33
;  DDRA=0xF8;
	ldi R24,248
	out 0x1a,R24
	.dbline 34
;  PORTB=0xFF;
	ldi R24,255
	out 0x18,R24
	.dbline 35
;  DDRB=0x00;
	clr R2
	out 0x17,R2
	.dbline 36
;  PORTC=0xFF;
	out 0x15,R24
	.dbline 37
;  DDRC=0x00;
	out 0x14,R2
	.dbline 38
;  PORTD=0x1F;
	ldi R24,31
	out 0x12,R24
	.dbline 39
;  DDRD=0xE0;
	ldi R24,224
	out 0x11,R24
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e timer0_init _timer0_init fV
	.even
_timer0_init::
	.dbline -1
	.dbline 49
; }
; 
; //------------------------------------------------------------------------------------------------------------
; //------------------------------------------------------------------------------------------------------------
; //TIMER0 initialisation - prescale:64
; // desired value: 1000Hz
; // actual value: 1000,000Hz (0,0%)
; 
; void timer0_init(void)  /* */
; {
	.dbline 50
;  TCCR0 = 0x00; //stop timer
	clr R2
	out 0x33,R2
	.dbline 51
;  TCNT0 = 0x83; //set count value
	ldi R24,131
	out 0x32,R24
	.dbline 52
;  TCCR0 = 0x03; //start timer, frequency = 0Hz
	ldi R24,3
	out 0x33,R24
	.dbline -2
L2:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e timer1_init _timer1_init fV
	.even
_timer1_init::
	.dbline -1
	.dbline 59
; }
; 
; //------------------------------------------------------------------------------------------------------------
; //------------------------------------------------------------------------------------------------------------
; 
; void timer1_init(void)  /* */
; {
	.dbline 60
;  TCCR1B = 0x00; //stop
	clr R2
	out 0x2e,R2
	.dbline 61
;  TCNT1H = 0x00 /*Initial setting*/; //setup
	out 0x2d,R2
	.dbline 62
;  TCNT1L = 0x00 /*Initial setting*/;
	out 0x2c,R2
	.dbline 63
;  OCR1AH = 0x00 /*Initial setting*/;
	out 0x2b,R2
	.dbline 64
;  OCR1AL = 0x00 /*Initial setting*/;
	out 0x2a,R2
	.dbline 65
;  OCR1BH = 0x00 /*Initial setting*/;
	out 0x29,R2
	.dbline 66
;  OCR1BL = 0x00 /*Initial setting*/;
	out 0x28,R2
	.dbline 67
;  TCCR1A = 0x00;
	out 0x2f,R2
	.dbline 68
;  TCCR1B = 0x00; //start Timer CLK=1/8, frequency = 0Hz
	out 0x2e,R2
	.dbline -2
L3:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e uart0_init _uart0_init fV
	.even
_uart0_init::
	.dbline -1
	.dbline 78
; }
; 
; //------------------------------------------------------------------------------------------------------------
; //------------------------------------------------------------------------------------------------------------
; 
; //UART0 initialisation
; // desired baud rate: 9600
; // actual: baud rate: 9615 (0,2%)
; void uart0_init(void)
; {
	.dbline 79
;  UCR=0x00;  //disable while setting baud rate
	clr R2
	out 0xa,R2
	.dbline 80
;  UBRR=0x33; //set baud rate
	ldi R24,51
	out 0x9,R24
	.dbline 81
;  UCR=0x00;  //enable
	out 0xa,R2
	.dbline -2
L4:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e init_devices _init_devices fV
	.even
_init_devices::
	.dbline -1
	.dbline 89
; }
; 
; //------------------------------------------------------------------------------------------------------------
; //------------------------------------------------------------------------------------------------------------
; 
; //call this routine to initialise all peripherals
; void init_devices(void)  /* */
; {
	.dbline 91
;  //stop errant interrupts until set up
;  CLI(); //disable all interrupts
	cli
	.dbline 93
; 
;  port_init();
	rcall _port_init
	.dbline 94
;  timer0_init();
	rcall _timer0_init
	.dbline 95
;  timer1_init();
	rcall _timer1_init
	.dbline 96
;  uart0_init();
	rcall _uart0_init
	.dbline 98
; 
;  WDTCR|=0x18;       //Watchdog turn off enable
	in R24,0x21
	ori R24,24
	out 0x21,R24
	.dbline 99
;  WDTCR&=0x10;       //Disable watchdog
	in R24,0x21
	andi R24,16
	out 0x21,R24
	.dbline 101
; 
;  MCUCR = 0x0E;      //Int0 falling edge, external SRAM disabled !Debug!
	ldi R24,14
	out 0x35,R24
	.dbline 102
;  GIMSK = 0x40;      //Int0 enabled
	ldi R24,64
	out 0x3b,R24
	.dbline 103
;  TIMSK = 0x01;      //Timer 1 Overflow Int disabled, Timer 0 overflow Int enabled
	ldi R24,1
	out 0x39,R24
	.dbline 104
;  SEI(); //re-enable interrupts
	sei
	.dbline -2
L5:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e rd_LCD _rd_LCD fc
;           var2 -> R16
	.even
_rd_LCD::
	.dbline -1
	.dbline 118
;  //all peripherals are now initialised
; }
; 
; //****************************************************************************************************
; //****************************************************************************************************
; 
; //read a byte from the LCD data register
; //control lines: LCD_Enable, LCD_RD//WR, LCD_Register_Sel
; //LCD latches databus contents at rising signal of E (LCD_Enable)
; //Data direction is adjusted by R//W (LCD_RD//WR)
; //Address the control reg by accessing RS (LCD_Register_Sel) RS=1 >> address Register
; 
; UInt8 rd_LCD(void)
; {
	.dbline 121
;  UInt8 var2;
; 
;  DDRC=0x00;		// Adjust data direction of Port C: set to input
	clr R2
	out 0x14,R2
	.dbline 123
; 
;  PORTD=0x40;		// E=0, R//W=1, RS=0
	ldi R24,64
	out 0x12,R24
	.dbline 124
;  PORTD=0xC0;		// E=1, R//W=1, RS=0
	ldi R24,192
	out 0x12,R24
	.dbline 125
;  PORTD=0xC0;		// E=1, R//W=1, RS=0
	out 0x12,R24
	.dbline 127
; 
;  var2=PINC;	// read contents at the bus taps
	in R16,0x13
	.dbline 129
; 
;  PORTD=0x40;		// E=0, R//W=1, RS=0
	ldi R24,64
	out 0x12,R24
	.dbline 131
; 
;  return(var2);
	.dbline -2
L6:
	.dbline 0 ; func end
	ret
	.dbsym r var2 16 c
	.dbend
	.dbfunc e LCD_busy_test _LCD_busy_test fV
	.even
_LCD_busy_test::
	.dbline -1
	.dbline 142
; }
; 
; //****************************************************************************************************
; //****************************************************************************************************
; 
; //test wether LCD-transaction is finished, use LCD-Busy flag in control register
; //and wait until finished
; 
; void LCD_busy_test(void)
; 
; {
L8:
	.dbline 143
L9:
	.dbline 143
;  while (rd_LCD()&0x80); //Bit 7 is the busy indicator of the LCD
	rcall _rd_LCD
	sbrc R16,7
	rjmp L8
	.dbline -2
L7:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e LCD_LED _LCD_LED fV
;              c -> R16
	.even
_LCD_LED::
	.dbline -1
	.dbline 153
; 
; }
; 
; //****************************************************************************************************
; //****************************************************************************************************
; 
; //switch LCD-Backlight LED ON or OFF
; 
; void LCD_LED(UInt8 c)
; {
	.dbline 155
; 
;  DDRA=0xF8;	// Adjust data direction of Port A: set all except 0,1,2 to output
	ldi R24,248
	out 0x1a,R24
	.dbline 156
;  if (c)
	tst R16
	breq L12
	.dbline 157
;   PORTA|=0x80;		// set PA7
	sbi 0x1b,7
	rjmp L13
L12:
	.dbline 159
	in R24,0x1b
	andi R24,127
	out 0x1b,R24
L13:
	.dbline -2
L11:
	.dbline 0 ; func end
	ret
	.dbsym r c 16 c
	.dbend
	.dbfunc e LCD_putc _LCD_putc fV
;              c -> R20
	.even
_LCD_putc::
	rcall push_gset1
	mov R20,R16
	.dbline -1
	.dbline 170
;  else
;   PORTA&=0x7F;		// clear PA7
; 
; }
; 
; 
; //****************************************************************************************************
; //****************************************************************************************************
; 
; //write a single character to the LCD
; 
; void LCD_putc(UInt8 c)
; {
	.dbline 171
;  LCD_busy_test();
	rcall _LCD_busy_test
	.dbline 172
;  if (c == '\n')
	cpi R20,10
	brne L15
	.dbline 173
;   wr_LCD_control(LCD_NEW_LINE);
	ldi R16,192
	rcall _wr_LCD_control
	rjmp L16
L15:
	.dbline 175
	mov R16,R20
	rcall _wr_LCD
L16:
	.dbline -2
L14:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r c 20 c
	.dbend
	.dbfunc e LCD_puts_const _LCD_puts_const fV
;              s -> R20,R21
	.even
_LCD_puts_const::
	rcall push_gset1
	mov R20,R16
	mov R21,R17
	.dbline -1
	.dbline 185
;  else
;   wr_LCD(c);
; }
; 
; 
; //****************************************************************************************************
; //****************************************************************************************************
; 
; //write a \0 terminated string to the LCD at a previously defined address
; 
; void LCD_puts_const(const UInt8 *s)
; {
	rjmp L19
L18:
	.dbline 186
;  while (*s) {
	.dbline 187
;  LCD_busy_test();
	rcall _LCD_busy_test
	.dbline 188
;  if (*s == '\n')
	mov R30,R20
	mov R31,R21
	lpm
	mov R24,R0
	cpi R24,10
	brne L21
	.dbline 189
;   wr_LCD_control(LCD_NEW_LINE);
	ldi R16,192
	rcall _wr_LCD_control
	rjmp L22
L21:
	.dbline 191
;  else
;   wr_LCD(*s);
	mov R30,R20
	mov R31,R21
	lpm
	mov R16,R0
	rcall _wr_LCD
L22:
	.dbline 192
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 193
L19:
	.dbline 186
	mov R30,R20
	mov R31,R21
	lpm
	tst R0
	brne L18
	.dbline -2
L17:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r s 20 pkc
	.dbend
	.dbfunc e LCD_puts _LCD_puts fV
;              s -> R20,R21
	.even
_LCD_puts::
	rcall push_gset1
	mov R20,R16
	mov R21,R17
	.dbline -1
	.dbline 201
;   ++s;
;  }
; }
; //****************************************************************************************************
; //****************************************************************************************************
; 
; //write a \0 terminated string to the LCD at a previously defined address
; 
; void LCD_puts(UInt8 *s)
; {
	rjmp L25
L24:
	.dbline 202
;  while (*s) {
	.dbline 203
;  LCD_busy_test();
	rcall _LCD_busy_test
	.dbline 204
;  if (*s == '\n')
	mov R30,R20
	mov R31,R21
	ldd R24,z+0
	cpi R24,10
	brne L27
	.dbline 205
;   wr_LCD_control(LCD_NEW_LINE);
	ldi R16,192
	rcall _wr_LCD_control
	rjmp L28
L27:
	.dbline 207
;  else
;   wr_LCD(*s);
	mov R30,R20
	mov R31,R21
	ldd R16,z+0
	rcall _wr_LCD
L28:
	.dbline 208
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 209
L25:
	.dbline 202
	mov R30,R20
	mov R31,R21
	ldd R2,z+0
	tst R2
	brne L24
	.dbline -2
L23:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r s 20 pc
	.dbend
	.dbfunc e LCD_command _LCD_command fV
;              c -> R20
	.even
_LCD_command::
	rcall push_gset1
	mov R20,R16
	.dbline -1
	.dbline 218
;   ++s;
;  }
; }
; 
; //****************************************************************************************************
; //****************************************************************************************************
; 
; //write a command to the LCD
; 
; void LCD_command(UInt8 c)
; {
	.dbline 219
;  LCD_busy_test();
	rcall _LCD_busy_test
	.dbline 220
;  wr_LCD_control(c);
	mov R16,R20
	rcall _wr_LCD_control
	.dbline -2
L29:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r c 20 c
	.dbend
	.dbfunc e LCD_init _LCD_init fV
;              i -> R20
	.even
_LCD_init::
	rcall push_gset1
	.dbline -1
	.dbline 228
; }
; 
; 
; //****************************************************************************************************
; //****************************************************************************************************
; 
; void LCD_init(void)							// UPH: Initialize the LCD.
; {
	.dbline 231
	clr R20
	rjmp L34
L31:
	.dbline 231
	.dbline 232
	rcall _LCD_busy_test
	.dbline 233
	ldi R24,<_init_tab
	ldi R25,>_init_tab
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	rcall _wr_LCD_control
	.dbline 234
L32:
	.dbline 231
	inc R20
L34:
	.dbline 231
; UInt8 i;
; 
;  for (i=0; i<5; i++) {
	cpi R20,5
	brlo L31
	.dbline -2
L30:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r i 20 c
	.dbend
	.dbfunc e LCD_reset _LCD_reset fV
	.even
_LCD_reset::
	.dbline -1
	.dbline 241
;   LCD_busy_test();
;   wr_LCD_control(init_tab[i]);
;  }
; }
; 
; //****************************************************************************************************
; //****************************************************************************************************
; 
; void LCD_reset(void)							// UPH: Initialize the LCD.
; {
	.dbline 243
; 
;  T0_Var1=15;
	ldi R24,15
	sts _T0_Var1,R24
L36:
	.dbline 244
L37:
	.dbline 244
;  while(T0_Var1);
	lds R2,_T0_Var1
	tst R2
	brne L36
	.dbline 245
;  wr_LCD_control(0x30);
	ldi R16,48
	rcall _wr_LCD_control
	.dbline 246
;  T0_Var1=5;
	ldi R24,5
	sts _T0_Var1,R24
L39:
	.dbline 247
L40:
	.dbline 247
;  while(T0_Var1);
	lds R2,_T0_Var1
	tst R2
	brne L39
	.dbline 248
;  wr_LCD_control(0x30);
	ldi R16,48
	rcall _wr_LCD_control
	.dbline 249
;  T0_Var1=1;
	ldi R24,1
	sts _T0_Var1,R24
L42:
	.dbline 250
L43:
	.dbline 250
;  while(T0_Var1);
	lds R2,_T0_Var1
	tst R2
	brne L42
	.dbline 251
;  wr_LCD_control(0x30);
	ldi R16,48
	rcall _wr_LCD_control
	.dbline -2
L35:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e wr_LCD _wr_LCD fV
;           data -> R16
	.even
_wr_LCD::
	.dbline -1
	.dbline 264
; }
; 
; //****************************************************************************************************
; //****************************************************************************************************
; 
; //write a byte to the LCD data register
; //control lines: LCD_Enable, LCD_RD//WR, LCD_Register_Sel
; //LCD latches databus contents at rising signal of E (LCD_Enable)
; //Data direction is adjusted by R//W (LCD_RD//WR)
; //Address the control reg by accessing RS (LCD_Register_Sel) RS=1 >> address Register
; 
; void wr_LCD(UInt8 data)
; {
	.dbline 268
; 
;  //strobe data to LCD
;  // prepare control lines of LCD
;  PORTD=0x20;		// E=0, R//W=0, RS=1
	ldi R24,32
	out 0x12,R24
	.dbline 269
;  DDRC=0xFF;		// Adjust data direction of Port C: set to output
	ldi R24,255
	out 0x14,R24
	.dbline 271
; 
;  PORTC=data;	// write contents to bus taps
	out 0x15,R16
	.dbline 273
; 
;  PORTD=0xA0;		// E=1, R//W=0, RS=1
	ldi R24,160
	out 0x12,R24
	.dbline 274
;  PORTD=0x20;		// E=0, R//W=0, RS=1
	ldi R24,32
	out 0x12,R24
	.dbline -2
L45:
	.dbline 0 ; func end
	ret
	.dbsym r data 16 c
	.dbend
	.dbfunc e wr_LCD_control _wr_LCD_control fV
;           data -> R16
	.even
_wr_LCD_control::
	.dbline -1
	.dbline 289
; 
; 
; }
; 
; //****************************************************************************************************
; //****************************************************************************************************
; 
; //write a byte to the LCD control register
; //control lines: LCD_Enable, LCD_RD//WR, LCD_Register_Sel
; //LCD latches databus contents at rising signal of E (LCD_Enable)
; //Data direction is adjusted by R//W (LCD_RD//WR)
; //Address the control reg by accessing RS (LCD_Register_Sel) RS=1 >> address Register
; 
; void wr_LCD_control(UInt8 data)
; {
	.dbline 291
;  // prepare control lines of LCD
;  PORTD=0x00;		// E=0, R//W=0, RS=0
	clr R2
	out 0x12,R2
	.dbline 292
;  DDRC=0xFF;		// Adjust data direction of Port C: set to output
	ldi R24,255
	out 0x14,R24
	.dbline 294
; 
;  PORTC=data;	// write contents to bus taps
	out 0x15,R16
	.dbline 296
; 
;  PORTD=0x80;		// E=1, R//W=0, RS=0
	ldi R24,128
	out 0x12,R24
	.dbline 297
;  PORTD=0x00;		// E=0, R//W=0, RS=0
	out 0x12,R2
	.dbline -2
L46:
	.dbline 0 ; func end
	ret
	.dbsym r data 16 c
	.dbend
	.dbfunc e write_4dig_hex_to_LCD _write_4dig_hex_to_LCD fV
;             ch -> R20
;              i -> y+2
	.even
_write_4dig_hex_to_LCD::
	st -y,r17
	st -y,r16
	rcall push_gset1
	.dbline -1
	.dbline 307
; 
; 
; }
; 
; //****************************************************************************************************
; //****************************************************************************************************
; 
; 
; void write_4dig_hex_to_LCD(const UInt16 i)  /* */
; {
	.dbline 311
; UInt8 ch;
; 
;  /* First digit */
;  if((ch=(((UInt8 *)&i)[1])>>4) < 10)
	ldd R24,y+3
	swap R24
	andi R24,#0x0F
	mov R20,R24
	cpi R20,10
	brsh L48
	.dbline 312
;    LCD_putc(ch+'0');
	mov R16,R24
	subi R16,208    ; addi 48
	rcall _LCD_putc
	rjmp L49
L48:
	.dbline 314
;  else
;    LCD_putc(ch+('A'-10));
	mov R16,R20
	subi R16,201    ; addi 55
	rcall _LCD_putc
L49:
	.dbline 316
;  /* Second digit */
;  if((ch=(((UInt8 *)&i)[1])&0x0F) < 10)
	ldd R24,y+3
	andi R24,15
	mov R20,R24
	cpi R20,10
	brsh L51
	.dbline 317
;    LCD_putc(ch+'0');
	mov R16,R24
	subi R16,208    ; addi 48
	rcall _LCD_putc
	rjmp L52
L51:
	.dbline 319
;  else
;    LCD_putc(ch+('A'-10));
	mov R16,R20
	subi R16,201    ; addi 55
	rcall _LCD_putc
L52:
	.dbline 321
; /* Third digit */
;  if((ch=(((UInt8 *)&i)[0])>>4) < 10)
	mov R30,R28
	mov R31,R29
	ldd R24,z+2
	swap R24
	andi R24,#0x0F
	mov R20,R24
	cpi R20,10
	brsh L54
	.dbline 322
;    LCD_putc(ch+'0');
	mov R16,R24
	subi R16,208    ; addi 48
	rcall _LCD_putc
	rjmp L55
L54:
	.dbline 324
;  else
;    LCD_putc(ch+('A'-10));
	mov R16,R20
	subi R16,201    ; addi 55
	rcall _LCD_putc
L55:
	.dbline 326
;  /* Fourth digit */
;  if((ch=(((UInt8 *)&i)[0])&0x0F) < 10)
	mov R30,R28
	mov R31,R29
	ldd R24,z+2
	andi R24,15
	mov R20,R24
	cpi R20,10
	brsh L56
	.dbline 327
;    LCD_putc(ch+'0');
	mov R16,R24
	subi R16,208    ; addi 48
	rcall _LCD_putc
	rjmp L57
L56:
	.dbline 329
	mov R16,R20
	subi R16,201    ; addi 55
	rcall _LCD_putc
L57:
	.dbline -2
L47:
	rcall pop_gset1
	adiw R28,2
	.dbline 0 ; func end
	ret
	.dbsym r ch 20 c
	.dbsym l i 2 ks
	.dbend
	.dbfunc e write_2dig_hex_to_LCD _write_2dig_hex_to_LCD fV
;             ch -> R20
;              i -> y+2
	.even
_write_2dig_hex_to_LCD::
	st -y,r17
	st -y,r16
	rcall push_gset1
	.dbline -1
	.dbline 338
;  else
;    LCD_putc(ch+('A'-10));
; 
; }
; 
; //****************************************************************************************************
; //****************************************************************************************************
; 
; 
; void write_2dig_hex_to_LCD(const UInt16 i)  /* */
; {
	.dbline 342
; UInt8 ch;
; 
;  /* First digit */
;  if((ch=(((UInt8 *)&i)[0])>>4) < 10)
	mov R30,R28
	mov R31,R29
	ldd R24,z+2
	swap R24
	andi R24,#0x0F
	mov R20,R24
	cpi R20,10
	brsh L59
	.dbline 343
;    LCD_putc(ch+'0');
	mov R16,R24
	subi R16,208    ; addi 48
	rcall _LCD_putc
	rjmp L60
L59:
	.dbline 345
;  else
;    LCD_putc(ch+('A'-10));
	mov R16,R20
	subi R16,201    ; addi 55
	rcall _LCD_putc
L60:
	.dbline 347
;  /* Second digit */
;  if((ch=(((UInt8 *)&i)[0])&0x0F) < 10)
	mov R30,R28
	mov R31,R29
	ldd R24,z+2
	andi R24,15
	mov R20,R24
	cpi R20,10
	brsh L61
	.dbline 348
;    LCD_putc(ch+'0');
	mov R16,R24
	subi R16,208    ; addi 48
	rcall _LCD_putc
	rjmp L62
L61:
	.dbline 350
	mov R16,R20
	subi R16,201    ; addi 55
	rcall _LCD_putc
L62:
	.dbline -2
L58:
	rcall pop_gset1
	adiw R28,2
	.dbline 0 ; func end
	ret
	.dbsym r ch 20 c
	.dbsym l i 2 ks
	.dbend
